# tome 📖

**tome** is a powerful script management tool designed to streamline the organization and
distribution of scripts across different environments. Built with flexibility and ease of
use in mind, **tome** enhances the way scripts of any kind are managed, shared, tested,
and maintained.

With **tome**, you can:

- **Organize** 📂: Effortlessly manage and structure your scripts for a clean, maintainable codebase.
- **Collaborate** 🤝: Seamlessly share and collaborate on scripts with your team to enhance productivity.
- **Test** 🧪: Ensure your scripts' reliability and performance with comprehensive testing tools.
- **Secure** 🔒: Manage and protect your passwords using the **tome** vaults.

## Installation

The recommended way to install **tome** is using `pip` within a virtual environment. This
ensures that your project dependencies are isolated and managed effectively:

1. Create a virtual environment:

```bash
python -m venv myenv
```

2. Activate the virtual environment:

On Windows:
```bash
myenv\Scripts\activate
```

On macOS/Linux:
```bash
source myenv/bin/activate
```

3. Install **tome** using `pip`:

```bash
pip install tomescripts
```

4. Now you can start using **tome**

## Documentation

For more detailed information on how to use **tome**, best practices, and guides, please
refer to our [official documentation](https://jfrog.github.io/tome/).

## Contribution

We welcome contributions to **tome**! Please read our contributing guidelines located in
[CONTRIBUTING.md](CONTRIBUTING.md) before submitting pull requests.

## Code of Conduct

We are committed to providing a welcoming and inspiring community for all. Please read
[CODE_OF_CONDUCT.md](CODE_OF_CONDUCT.md) in this repository for details on our code of
conduct, which outlines our expectations for participants within the community.

## License

**tome** is released under the Apache License. See the bundled [LICENSE](LICENSE) file for
details.
