import hashlib


class Emojinator:
    def __init__(self):
        self.emoji_dict = {
            "release": "🏷️ ",
            "chat": "💬",
            "ai": "🤖",
            "robot": "🤖",
            "rabbit": "🐇",
            "jenkins": "🤖",
            "terraform": "🌍",
            "ansible": "📜",
            "sql": "🗄️",
            "mysql": "🐬",
            "postgresql": "🐘",
            "mongodb": "🍃",
            "redis": "🔴",
            "docker": "🐳",
            "k8s": "☸️ ",
            "kubernetes": "☸️ ",
            "helm": "⚓",
            "python": "🐍",
            "javascript": "🟨",
            "typescript": "🔵",
            "java": "☕",
            "kotlin": "🅺",
            "swift": "🦅",
            "go": "🐹",
            "ruby": "💎",
            "php": "🐘",
            "csharp": "♯",
            "cpp": "➕",
            "html": "📄",
            "css": "🎨",
            "sass": "💄",
            "aws": "☁️ ",
            "azure": "🔵",
            "gcp": "🌐",
            "git": "🔧",
            "github": "🐱",
            "gitlab": "🦊",
            "bitbucket": "🪣",
            "ci": "🚀",
            "cd": "🚀",
            "test": "🐞",
            "pytest": "🐞",
            "junit": "🧪",
            "mocha": "☕",
            "chai": "🍵",
            "django": "🌐",
            "flask": "🌶️",
            "express": "🚂",
            "react": "⚛️",
            "vue": "🖼️",
            "angular": "📐",
            "svelte": "🔥",
            "nextjs": "➡️",
            "nuxtjs": "🌟",
            "graphql": "🔺",
            "apollo": "🚀",
            "prometheus": "🛡️ ",
            "grafana": "📊",
            "splunk": "🔍",
            "datadog": "🐶",
            "newrelic": "🆕",
            "elk": "🦌",
            "elastic": "🔍",
            "logstash": "📊",
            "kibana": "📈",
            "linux": "🐧",
            "ubuntu": "🔶",
            "centos": "🔵",
            "debian": "🟥",
            "windows": "🪟",
            "macos": "🍏",
            "android": "🤖",
            "ios": "📱",
            "firefox": "🦊",
            "chrome": "🌐",
            "edge": "🌀",
            "safari": "🧭",
            "docker-compose": "🐳🔧",
            "npm": "📦",
            "yarn": "🧶",
            "bash": "🐚",
            "shell": "🐚",
            "zsh": "🐚",
            "powershell": "⚡",
            "finance": "💰",
            "file": "📁",
            "server": "📡",
            "system": "🖥️ ",
            "network": "🌐",
            "todo": "📝",
            "weather": "🌤️ ",
            "x": "🐦",
            "calendar": "📅",
            "clock": "⏰",
            "hourglass": "⏳",
            "utility": "🔧",
        }

        self.default_emojis = [
            "🐶",
            "🐱",
            "🐭",
            "🐹",
            "🐰",
            "🦊",
            "🐻",
            "🐼",
            "🐨",
            "🐯",
            "🦁",
            "🐮",
            "🐷",
            "🐽",
            "🐸",
            "🐵",
            "🦄",
            "🐝",
            "🐛",
            "🦋",
            "🐌",
            "🐞",
            "🐜",
            "🪲",
            "🐢",
            "🐍",
            "🦎",
            "🐙",
            "🦑",
            "🦐",
            "🦞",
            "🦀",
            "🐡",
            "🐠",
            "🐟",
            "🐬",
            "🐳",
            "🐋",
            "🦈",
            "🐊",
            "🐅",
            "🐆",
            "🦓",
            "🦍",
            "🦧",
            "🦣",
            "🦏",
            "🐘",
            "🦛",
            "🐪",
            "🐫",
            "🦙",
            "🦒",
            "🐃",
            "🐂",
            "🐎",
            "🐖",
            "🐏",
            "🐑",
            "🦌",
            "🐐",
            "🐓",
            "🦃",
            "🦤",
            "🐕",
            "🐩",
            "🦮",
            "🐕‍🦺",
            "🐈",
            "🐈‍⬛",
            "🪶",
            "🦜",
            "🦢",
            "🦩",
            "🕊️",
            "🐇",
            "🦝",
            "🦨",
            "🦡",
            "🦦",
            "🦥",
            "🐁",
            "🐀",
            "🐿️",
            "🦔",
            "🌵",
            "🎄",
            "🌲",
            "🌳",
            "🌴",
            "🪵",
            "🌱",
            "🌿",
            "☘️",
            "🍀",
            "🎍",
            "🪴",
            "🎋",
            "🍃",
            "🍂",
            "🍁",
            "🍄",
            "🐚",
            "🪨",
            "🌍",
            "🌎",
            "🌏",
            "🌐",
            "🪐",
            "🌤️",
            "⛅",
            "🌥️",
            "🌦️",
            "🌈",
            "☁️",
            "🌧️",
            "⛈️",
            "🌩️",
            "🌨️",
            "❄️",
            "☃️",
            "⛄",
            "🌬️",
            "💨",
            "💧",
            "💦",
            "🌊",
            "🔥",
            "💫",
            "⭐",
            "🌟",
            "✨",
            "⚡",
            "⛱️",
        ]

    def get_emoji(self, namespace):
        # Check for matches in the namespace
        for key in self.emoji_dict:
            if key in namespace:
                return self.emoji_dict[key]

        # If no specific match found, return a hashed default emoji
        return self.get_hashed_emoji(namespace)

    def get_hashed_emoji(self, namespace):
        # Hash the namespace to get a consistent but seemingly random index
        hash_object = hashlib.md5(namespace.encode())
        hash_value = int(hash_object.hexdigest(), 16)
        # Use the hash value to get a predictable index for the default emojis
        index = hash_value % len(self.default_emojis)
        return self.default_emojis[index]
